<!doctype html>
<html lang="en">
<head>
<title>How to use optitrack with ROS</title>
<!-- 2019-11-15 ven. 15:59 -->
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="generator" content="Org-mode">
<meta name="author" content="Virgile Daugé">

<link  href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.5/css/bootstrap.min.css" rel="stylesheet">
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.5/js/bootstrap.min.js"></script>
<style type="text/css">
/* org mode styles on top of twbs */

html {
    position: relative;
    min-height: 100%;
}

body {
    font-size: 18px;
    margin-bottom: 105px;
}

footer {
    position: absolute;
    bottom: 0;
    width: 100%;
    height: 101px;
    background-color: #f5f5f5;
}

footer > div {
    padding: 10px;
}

footer p {
    margin: 0 0 5px;
    text-align: center;
    font-size: 16px;
}

#table-of-contents {
    margin-top: 20px;
    margin-bottom: 20px;
}

blockquote p {
    font-size: 18px;
}

pre {
    font-size: 16px;
}

.footpara {
    display: inline-block;
}

figcaption {
  font-size: 16px;
  color: #666;
  font-style: italic;
  padding-bottom: 15px;
}

/* from twbs docs */

.bs-docs-sidebar.affix {
    position: static;
}
@media (min-width: 768px) {
    .bs-docs-sidebar {
        padding-left: 20px;
    }
}

/* All levels of nav */
.bs-docs-sidebar .nav > li > a {
    display: block;
    padding: 4px 20px;
    font-size: 14px;
    font-weight: 500;
    color: #999;
}
.bs-docs-sidebar .nav > li > a:hover,
.bs-docs-sidebar .nav > li > a:focus {
    padding-left: 19px;
    color: #A1283B;
    text-decoration: none;
    background-color: transparent;
    border-left: 1px solid #A1283B;
}
.bs-docs-sidebar .nav > .active > a,
.bs-docs-sidebar .nav > .active:hover > a,
.bs-docs-sidebar .nav > .active:focus > a {
    padding-left: 18px;
    font-weight: bold;
    color: #A1283B;
    background-color: transparent;
    border-left: 2px solid #A1283B;
}

/* Nav: second level (shown on .active) */
.bs-docs-sidebar .nav .nav {
    display: none; /* Hide by default, but at >768px, show it */
    padding-bottom: 10px;
}
.bs-docs-sidebar .nav .nav > li > a {
    padding-top: 1px;
    padding-bottom: 1px;
    padding-left: 30px;
    font-size: 12px;
    font-weight: normal;
}
.bs-docs-sidebar .nav .nav > li > a:hover,
.bs-docs-sidebar .nav .nav > li > a:focus {
    padding-left: 29px;
}
.bs-docs-sidebar .nav .nav > .active > a,
.bs-docs-sidebar .nav .nav > .active:hover > a,
.bs-docs-sidebar .nav .nav > .active:focus > a {
    padding-left: 28px;
    font-weight: 500;
}

/* Nav: third level (shown on .active) */
.bs-docs-sidebar .nav .nav .nav {
    padding-bottom: 10px;
}
.bs-docs-sidebar .nav .nav .nav > li > a {
    padding-top: 1px;
    padding-bottom: 1px;
    padding-left: 40px;
    font-size: 12px;
    font-weight: normal;
}
.bs-docs-sidebar .nav .nav .nav > li > a:hover,
.bs-docs-sidebar .nav .nav .nav > li > a:focus {
    padding-left: 39px;
}
.bs-docs-sidebar .nav .nav .nav > .active > a,
.bs-docs-sidebar .nav .nav .nav > .active:hover > a,
.bs-docs-sidebar .nav .nav .nav > .active:focus > a {
    padding-left: 38px;
    font-weight: 500;
}

/* Show and affix the side nav when space allows it */
@media (min-width: 992px) {
    .bs-docs-sidebar .nav > .active > ul {
        display: block;
    }
    /* Widen the fixed sidebar */
    .bs-docs-sidebar.affix,
    .bs-docs-sidebar.affix-bottom {
        width: 213px;
    }
    .bs-docs-sidebar.affix {
        position: fixed; /* Undo the static from mobile first approach */
        top: 20px;
    }
    .bs-docs-sidebar.affix-bottom {
        position: absolute; /* Undo the static from mobile first approach */
    }
    .bs-docs-sidebar.affix .bs-docs-sidenav,.bs-docs-sidebar.affix-bottom .bs-docs-sidenav {
        margin-top: 0;
        margin-bottom: 0
    }
}
@media (min-width: 1200px) {
    /* Widen the fixed sidebar again */
    .bs-docs-sidebar.affix-bottom,
    .bs-docs-sidebar.affix {
        width: 263px;
    }
}
</style>
<script type="text/javascript">
$(function() {
    'use strict';

    $('.bs-docs-sidebar li').first().addClass('active');

    $(document.body).scrollspy({target: '.bs-docs-sidebar'});

    $('.bs-docs-sidebar').affix();
});
</script>
</head>
<body>
<div id="content" class="container">
<div class="row"><div class="col-md-9"><h1 class="title">How to use optitrack with ROS</h1>


<div id="outline-container-sec-1" class="outline-2">
<h2 id="sec-1"><span class="section-number-2">1</span> Package setup</h2>
<div class="outline-text-2" id="text-1">
<p>
Define the name of the project:
</p>
<div class="org-src-container">

<pre class="src src-text" id="project_name">optitrack-basics
</pre>
</div>

<p>
We need to define two files, one package description and one cmake file.
We will need to use vrpn client from <a href="http://wiki.ros.org/vrpn_client_ros">http://wiki.ros.org/vrpn_client_ros</a>
</p>

<pre class="example">
sudo apt install ros-melodic-vrpn-client-ros
</pre>
<p>
First is package.xml in the root directory
</p>
<div class="org-src-container">

<pre class="src src-xml"><span style="color: #98be65;">&lt;?</span><span style="color: #51afef;">xml</span><span style="color: #98be65;"> </span><span style="color: #83898d;">version="1.0"</span><span style="color: #98be65;">?&gt;</span>
&lt;<span style="color: #c678dd;">package</span> <span style="color: #dcaeea;">format</span>=<span style="color: #98be65;">"2"</span>&gt;
  &lt;<span style="color: #c678dd;">name</span>&gt;optitrack-basics&lt;/<span style="color: #c678dd;">name</span>&gt;
  &lt;<span style="color: #c678dd;">version</span>&gt;0.0.1&lt;/<span style="color: #c678dd;">version</span>&gt;
  &lt;<span style="color: #c678dd;">description</span>&gt;description of the package&lt;/<span style="color: #c678dd;">description</span>&gt;
  &lt;<span style="color: #c678dd;">maintainer</span> <span style="color: #dcaeea;">email</span>=<span style="color: #98be65;">"virgile.dauge@loria.fr"</span>&gt;virgile&lt;/<span style="color: #c678dd;">maintainer</span>&gt;
  &lt;<span style="color: #c678dd;">license</span>&gt;TODO&lt;/<span style="color: #c678dd;">license</span>&gt;
  &lt;<span style="color: #c678dd;">buildtool_depend</span>&gt;catkin&lt;/<span style="color: #c678dd;">buildtool_depend</span>&gt;
  &lt;<span style="color: #c678dd;">build_export_depend</span>&gt;roscpp&lt;/<span style="color: #c678dd;">build_export_depend</span>&gt;
  &lt;<span style="color: #c678dd;">exec_depend</span>&gt;roscpp&lt;/<span style="color: #c678dd;">exec_depend</span>&gt;
  &lt;<span style="color: #c678dd;">build_depend</span>&gt;roscpp&lt;/<span style="color: #c678dd;">build_depend</span>&gt;
  &lt;<span style="color: #c678dd;">exec_depend</span>&gt;ros-melodic-vrpn-client-ros&lt;/<span style="color: #c678dd;">exec_depend</span>&gt;
&lt;/<span style="color: #c678dd;">package</span>&gt;
</pre>
</div>

<p>
We will also use catkin simple:
<a href="https://github.com/catkin/catkin_simple">https://github.com/catkin/catkin_simple</a>
</p>
<pre class="example">
cd ~/catkin_ws/src/
git clone https://github.com/catkin/catkin_simple.git
cd ~/catkin_ws/
catkin_make
</pre>

<p>
We also need a CMakelist.txt in the root directory
</p>
<div class="org-src-container">

<pre class="src src-cmake">cmake_minimum_required(VERSION 2.8.3)
project(optitrack-basics)

set (CMAKE_CXX_STANDARD 17)

find_package(catkin_simple REQUIRED)

catkin_simple()

#cs_add_library(my_lib src/my_lib.cpp)

cs_add_executable(pose_reader_node src/pose_reader_node.cpp)
#target_link_libraries(save_one my_lib)

cs_install()
# Python packages example
#cs_install_scripts(scripts/my_script.py)

#cs_export()
</pre>
</div>
</div>
</div>

<div id="outline-container-sec-2" class="outline-2">
<h2 id="sec-2"><span class="section-number-2">2</span> Reader node</h2>
<div class="outline-text-2" id="text-2">
<p>
PoseStamped msg info:
</p>
<div class="org-src-container">

<pre class="src src-bash">rosmsg show geometry_msgs/PoseStamped
</pre>
</div>

<pre class="example">
std_msgs/Header header
  uint32 seq
  time stamp
  string frame_id
geometry_msgs/Pose pose
  geometry_msgs/Point position
    float64 x
    float64 y
    float64 z
  geometry_msgs/Quaternion orientation
    float64 x
    float64 y
    float64 z
    float64 w

</pre>

<p>
We need ot define the behaviour of our reader in src/
</p>
<div class="org-src-container">

<pre class="src src-c++"><span style="color: #51afef; font-weight: bold;">#include</span> <span style="color: #51afef;">&lt;</span><span style="color: #98be65;">ros/ros.h</span><span style="color: #51afef;">&gt;</span>

<span style="color: #51afef; font-weight: bold;">#include</span> <span style="color: #51afef;">&lt;</span><span style="color: #98be65;">ros/console.h</span><span style="color: #51afef;">&gt;</span>
<span style="color: #51afef; font-weight: bold;">#include</span> <span style="color: #51afef;">&lt;</span><span style="color: #98be65;">geometry_msgs/PoseStamped.h</span><span style="color: #51afef;">&gt;</span>
<span style="color: #51afef; font-weight: bold;">#include</span> <span style="color: #51afef;">&lt;</span><span style="color: #98be65;">geometry_msgs/TwistStamped.h</span><span style="color: #51afef;">&gt;</span>
<span style="color: #51afef; font-weight: bold;">#include</span> <span style="color: #51afef;">&lt;</span><span style="color: #98be65;">geometry_msgs/AccelStamped.h</span><span style="color: #51afef;">&gt;</span>

<span style="color: #ECBE7B;">void</span> <span style="color: #c678dd;">poseCallback</span><span style="color: #51afef;">(</span><span style="color: #51afef;">const</span> <span style="color: #a9a1e1;">geometry_msgs</span>::<span style="color: #ECBE7B;">PoseStamped</span>&amp; <span style="color: #dcaeea;">msg</span><span style="color: #51afef;">){</span>
  ROS_INFO_STREAM<span style="color: #c678dd;">(</span><span style="color: #98be65;">"Pose"</span> &lt;&lt; <span style="color: #c678dd;">)</span>;
<span style="color: #51afef;">}</span>
<span style="color: #5B6268;">// </span><span style="color: #5B6268;">void TwistCallback(const geometry_msgs::TwistStamped::ConsPtr&amp; msg){</span>
<span style="color: #5B6268;">//   </span><span style="color: #5B6268;">printf ("Cloud: width = %d, height = %d\n", cloud-&gt;width, cloud-&gt;height);</span>
<span style="color: #5B6268;">// </span><span style="color: #5B6268;">}</span>
<span style="color: #5B6268;">// </span><span style="color: #5B6268;">void AccelCallback(const geometry_msgs::AccelStamped::ConsPtr&amp; msg){</span>
<span style="color: #5B6268;">//   </span><span style="color: #5B6268;">printf ("Cloud: width = %d, height = %d\n", cloud-&gt;width, cloud-&gt;height);</span>
<span style="color: #5B6268;">// </span><span style="color: #5B6268;">}</span>

<span style="color: #ECBE7B;">int</span> <span style="color: #c678dd;">main</span><span style="color: #51afef;">(</span><span style="color: #ECBE7B;">int</span> <span style="color: #dcaeea;">argc</span>, <span style="color: #ECBE7B;">char</span>** <span style="color: #dcaeea;">argv</span><span style="color: #51afef;">){</span>
  <span style="color: #a9a1e1;">ros</span>::init<span style="color: #c678dd;">(</span>argc, argv, <span style="color: #98be65;">"pose_reader"</span><span style="color: #c678dd;">)</span>;
  <span style="color: #a9a1e1;">ros</span>::<span style="color: #ECBE7B;">NodeHandle</span> <span style="color: #dcaeea;">nh</span>;
  <span style="color: #a9a1e1;">std</span>::<span style="color: #ECBE7B;">string</span> <span style="color: #dcaeea;">target</span>;
  <span style="color: #51afef;">if</span> <span style="color: #c678dd;">(</span>nh.getParam<span style="color: #98be65;">(</span><span style="color: #98be65;">"target"</span>, target<span style="color: #98be65;">)</span><span style="color: #c678dd;">){</span>
    ROS_INFO_STREAM<span style="color: #98be65;">(</span><span style="color: #98be65;">"Got param: "</span> &lt;&lt; target<span style="color: #98be65;">)</span>;
  <span style="color: #c678dd;">}</span>
  <span style="color: #51afef;">else</span><span style="color: #c678dd;">{</span>
    ROS_ERROR<span style="color: #98be65;">(</span><span style="color: #98be65;">"Failed to get param 'target'"</span><span style="color: #98be65;">)</span>;
  <span style="color: #c678dd;">}</span>
  <span style="color: #a9a1e1;">ros</span>::<span style="color: #ECBE7B;">Subscriber</span> <span style="color: #dcaeea;">poseSub</span> = nh.subscribe<span style="color: #c678dd;">&lt;</span><span style="color: #a9a1e1;">geometry_msgs</span>::<span style="color: #ECBE7B;">PoseStamped</span><span style="color: #c678dd;">&gt;(</span>target+<span style="color: #98be65;">"/pose"</span>, 1, poseCallback<span style="color: #c678dd;">)</span>;
  <span style="color: #5B6268;">// </span><span style="color: #5B6268;">ros::Subscriber twistSub = nh.subscribe&lt;geometry_msgs::TwistStamped&gt;("velodyne_points", 1, callback);</span>
  <span style="color: #5B6268;">// </span><span style="color: #5B6268;">ros::Subscriber accelSub = nh.subscribe&lt;geometry_msgs::AccelStamped&gt;("velodyne_points", 1, callback);</span>
  <span style="color: #a9a1e1;">ros</span>::spin<span style="color: #c678dd;">()</span>;
<span style="color: #51afef;">}</span>
</pre>
</div>
</div>
</div>

<div id="outline-container-sec-3" class="outline-2">
<h2 id="sec-3"><span class="section-number-2">3</span> Launchfile</h2>
<div class="outline-text-2" id="text-3">
<div class="org-src-container">

<pre class="src src-xml">  &lt;<span style="color: #c678dd;">launch</span>&gt;
    &lt;<span style="color: #c678dd;">arg</span> <span style="color: #dcaeea;">name</span>=<span style="color: #98be65;">"server"</span> <span style="color: #dcaeea;">default</span>=<span style="color: #98be65;">"192.168.2.102"</span>/&gt;
    &lt;<span style="color: #c678dd;">node</span> <span style="color: #dcaeea;">pkg</span>=<span style="color: #98be65;">"vrpn_client_ros"</span> <span style="color: #dcaeea;">type</span>=<span style="color: #98be65;">"vrpn_client_node"</span> <span style="color: #dcaeea;">name</span>=<span style="color: #98be65;">"vrpn_client_node"</span> <span style="color: #dcaeea;">output</span>=<span style="color: #98be65;">"screen"</span>&gt;
      &lt;<span style="color: #c678dd;">rosparam</span> <span style="color: #dcaeea;">subst_value</span>=<span style="color: #98be65;">"true"</span>&gt;
        server: $(arg server)
        port: 3883

        update_frequency: 100.0
        frame_id: world

        # Use the VRPN server's time, or the client's ROS time.
        use_server_time: false
        broadcast_tf: true

        # Must either specify refresh frequency &gt; 0.0, or a list of trackers to create
        refresh_tracker_frequency: 1.0
        #trackers:
        #- FirstTracker
        #- SecondTracker
      &lt;/<span style="color: #c678dd;">rosparam</span>&gt;
    &lt;/<span style="color: #c678dd;">node</span>&gt;
    &lt;<span style="color: #c678dd;">node</span> <span style="color: #dcaeea;">pkg</span>="&lt;&lt;<span style="color: #c678dd;">package_name</span>&gt;&gt;"
          type="pose_reader_node"
          name="pose_reader"
          output="screen"&gt;
    &lt;/<span style="color: #c678dd;">node</span>&gt;
&lt;/<span style="color: #c678dd;">launch</span>&gt;
</pre>
</div>
</div>
</div>

<div id="outline-container-sec-4" class="outline-2">
<h2 id="sec-4"><span class="section-number-2">4</span> Compile :</h2>
<div class="outline-text-2" id="text-4">
<div class="org-src-container">

<pre class="src src-bash"><span style="color: #c678dd;">cd</span> ~/catkin_ws/
catkin_make
</pre>
</div>
</div>
</div>
</div><div class="col-md-3"><nav id="table-of-contents">
<div id="text-table-of-contents" class="bs-docs-sidebar">
<ul class="nav">
<li><a href="#sec-1">1. Package setup</a></li>
<li><a href="#sec-2">2. Reader node</a></li>
<li><a href="#sec-3">3. Launchfile</a></li>
<li><a href="#sec-4">4. Compile :</a></li>
</ul>
</div>
</nav>
</div></div></div>
<footer id="postamble" class="">
<div><p class="author">Author: Virgile Daugé</p>
<p class="date">Created: 2019-11-15 ven. 15:59</p>
<p class="creator"><a href="http://www.gnu.org/software/emacs/">Emacs</a> 26.3 (<a href="http://orgmode.org">Org-mode</a> 9.1.9)</p>
</div>
</footer>
</body>
</html>
